Loading...
Searching...
No Matches
pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 > Class Reference
Module filters

RadiusOutlierRemoval is a simple filter that removes outliers if the number of neighbors in a certain search radius is smaller than a given K. More...

`#include <pcl/filters/radius_outlier_removal.h>`

Inheritance diagram for pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >:

## Public Member Functions

| RadiusOutlierRemoval (bool extract_removed_indices=false)
| Empty constructor.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the k-nearest neighbors for filtering.
double | getRadiusSearch ()
| Get the sphere radius used for determining the k-nearest neighbors.
void | setMinNeighborsInRadius (int min_pts)
| Set the minimum number of neighbors that a point needs to have in the given search radius in order to be considered an inlier (i.e., valid).
double | getMinNeighborsInRadius ()
| Get the minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier and avoid being filtered.
Public Member Functions inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor.
virtual | ~PCLBase ()=default
| destructor.
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset.
PCLPointCloud2ConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
IndicesPtr const | getIndices () const
| Get a pointer to the vector of indices used.

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output) override
| Abstract filter method for point cloud.
void | applyFilter (Indices &indices) override
| Abstract filter method for point cloud indices.
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

double | search_radius_ {0.0}
| The nearest neighbors search radius for each point.
int | min_pts_radius_ {1}
| The minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier.
KdTreePtr | searcher_
| A pointer to the spatial search object.
Protected Attributes inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
std::string | filter_name_
| The filter name.
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.
std::vector< uindex_t > | field_sizes_
| The size of each individual field.
index_t | x_idx_
| The x-y-z fields indices.
index_t | y_idx_
index_t | z_idx_
std::string | x_field_name_
| The desired x-y-z field names.
std::string | y_field_name_
std::string | z_field_name_

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
using | Ptr = shared_ptr< Filter< pcl::PCLPointCloud2 > >
using | ConstPtr = shared_ptr< const Filter< pcl::PCLPointCloud2 > >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

RadiusOutlierRemoval is a simple filter that removes outliers if the number of neighbors in a certain search radius is smaller than a given K.

Author
  Radu Bogdan Rusu

Definition at line 213 of file radius_outlier_removal.h.

## Constructor & Destructor Documentation

## RadiusOutlierRemoval()

pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::RadiusOutlierRemoval | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Definition at line 230 of file radius_outlier_removal.h.

## Member Function Documentation

## applyFilter() [1/2]

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::applyFilter | ( | Indices & | indices | ) |

override protected virtual

Abstract filter method for point cloud indices.

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## applyFilter() [2/2]

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

override protected virtual

Abstract filter method for point cloud.

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## getMinNeighborsInRadius()

double pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::getMinNeighborsInRadius | ( |  | ) |

inline

Get the minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier and avoid being filtered.

Definition at line 266 of file radius_outlier_removal.h.

## getRadiusSearch()

double pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::getRadiusSearch | ( |  | ) |

inline

Get the sphere radius used for determining the k-nearest neighbors.

Definition at line 247 of file radius_outlier_removal.h.

## setMinNeighborsInRadius()

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::setMinNeighborsInRadius | ( | int | min_pts | ) |

inline

Set the minimum number of neighbors that a point needs to have in the given search radius in order to be considered an inlier (i.e., valid).

Parameters

  min_pts | the minimum number of neighbors

Definition at line 257 of file radius_outlier_removal.h.

## setRadiusSearch()

void pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::setRadiusSearch | ( | double | radius | ) |

inline

Set the sphere radius that is to be used for determining the k-nearest neighbors for filtering.

Parameters

  radius | the sphere radius that is to contain all k-nearest neighbors

Definition at line 240 of file radius_outlier_removal.h.

## Member Data Documentation

## min_pts_radius_

int pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::min_pts_radius_ {1}

protected

The minimum number of neighbors that a point needs to have in the given search radius to be considered an inlier.

Definition at line 278 of file radius_outlier_removal.h.

## search_radius_

double pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::search_radius_ {0.0}

protected

The nearest neighbors search radius for each point.

Definition at line 273 of file radius_outlier_removal.h.

## searcher_

KdTreePtr pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::searcher_

protected

A pointer to the spatial search object.

Definition at line 281 of file radius_outlier_removal.h.

The documentation for this class was generated from the following file:

- pcl/filters/radius_outlier_removal.h